%global namedreltag %{nil}
%global namedversion %{version}%{?namedreltag}
Name:          cometd
Version:       3.0.9
Release:       1%{?dist}
Summary:       A scalable HTTP-based event routing bus
License:       ASL 2.0
URL:           http://cometd.org/
Source0:       https://github.com/cometd/cometd/archive/%{namedversion}.tar.gz
# https://github.com/cometd/cometd/issues/632
Patch0:        https://github.com/ghoullier/cometd/commit/b731695691a67518f2d5d64fc74ac7ee091d3cf7.patch
# Thanks to Juan Hernández jhernand[AT]redhat[DOT]com
# https://github.com/cometd/cometd/issues/631
Patch1:        cometd-3.0.9-adjust-to-jetty-9.3.patch

BuildRequires: maven-local
BuildRequires: mvn(com.fasterxml.jackson.core:jackson-databind)
BuildRequires: mvn(com.google.inject:guice)
BuildRequires: mvn(javax.annotation:jsr250-api)
BuildRequires: mvn(javax.inject:javax.inject)
BuildRequires: mvn(javax.servlet:javax.servlet-api)
BuildRequires: mvn(javax.websocket:javax.websocket-api)
BuildRequires: mvn(javax.websocket:javax.websocket-client-api)
BuildRequires: mvn(junit:junit)
BuildRequires: mvn(org.apache.felix:maven-bundle-plugin)
BuildRequires: mvn(org.apache.maven.plugins:maven-enforcer-plugin)
BuildRequires: mvn(org.apache.maven.plugins:maven-war-plugin)
BuildRequires: mvn(org.codehaus.jackson:jackson-core-asl)
BuildRequires: mvn(org.codehaus.jackson:jackson-mapper-asl)
BuildRequires: mvn(org.codehaus.mojo:exec-maven-plugin)
BuildRequires: mvn(org.eclipse.jetty:jetty-client)
BuildRequires: mvn(org.eclipse.jetty:jetty-continuation)
BuildRequires: mvn(org.eclipse.jetty:jetty-http)
BuildRequires: mvn(org.eclipse.jetty:jetty-io)
BuildRequires: mvn(org.eclipse.jetty:jetty-jmx)
BuildRequires: mvn(org.eclipse.jetty:jetty-proxy)
BuildRequires: mvn(org.eclipse.jetty:jetty-server)
BuildRequires: mvn(org.eclipse.jetty:jetty-servlet)
BuildRequires: mvn(org.eclipse.jetty:jetty-util)
BuildRequires: mvn(org.eclipse.jetty:jetty-util-ajax)
BuildRequires: mvn(org.eclipse.jetty.websocket:websocket-api)
BuildRequires: mvn(org.eclipse.jetty.websocket:websocket-client)
BuildRequires: mvn(org.eclipse.jetty.websocket:websocket-common)
BuildRequires: mvn(org.eclipse.jetty.websocket:websocket-server)
BuildRequires: mvn(org.eclipse.jetty.websocket:javax-websocket-client-impl)
BuildRequires: mvn(org.eclipse.jetty.websocket:javax-websocket-server-impl)
BuildRequires: mvn(org.hamcrest:hamcrest-library)
BuildRequires: mvn(org.slf4j:slf4j-api)
BuildRequires: mvn(org.slf4j:slf4j-log4j12)

%if 0
# cometd-java-benchmark
BuildRequires: mvn(org.eclipse.jetty.toolchain:jetty-perf-helper)
# cometd-java-oort
BuildRequires: mvn(org.eclipse.jetty.toolchain:jetty-test-helper)
# cometd-javascript
BuildRequires: mvn(net.alchim31.maven:yuicompressor-maven-plugin)
# Unavailable test deps
BuildRequires: mvn(org.eclipse.jetty:jetty-proxy:9.2.5.v20141112)
BuildRequires: mvn(org.springframework:spring-beans:4.2.4.RELEASE)
BuildRequires: mvn(org.springframework:spring-context:4.2.4.RELEASE)
BuildRequires: mvn(org.springframework:spring-web:4.2.4.RELEASE)
%endif

BuildArch:     noarch

%description
Cometd is a scalable HTTP-based event routing bus that uses
a Ajax Push technology pattern known as Comet. The term
'Comet' was coined by Alex Russell in his post Comet: Low
Latency Data for the Browser.

%package bayeux-api
Summary:       CometD :: Bayeux API

%description bayeux-api
CometD :: Bayeux API.

%package java
Summary:       CometD :: Java (Parent pom)

%description java
CometD :: Java (Parent pom).

%package java-annotations
Summary:       CometD :: Java :: Annotations

%description java-annotations
CometD :: Java :: Annotations.

%if 0
%package java-benchmark
Summary:       CometD :: Java :: Benchmark

%description java-benchmark
CometD :: Java :: Benchmark.

%package java-benchmark-client
Summary:       CometD :: Java :: Benchmark :: Client

%description java-benchmark-client
CometD :: Java :: Benchmark :: Client.

%package java-benchmark-common
Summary:       CometD :: Java :: Benchmark :: Common

%description java-benchmark-common
CometD :: Java :: Benchmark :: Common.

%package java-benchmark-server
Summary:       CometD :: Java :: Benchmark :: Server   

%description java-benchmark-server
CometD :: Java :: Benchmark :: Server.
%endif

%package java-client
Summary:       CometD :: Java :: Bayeux Client

%description java-client
CometD :: Java :: Bayeux Client.

%package java-common
Summary:       CometD :: Java :: Bayeux Common

%description java-common
CometD :: Java :: Bayeux Common.

%package java-oort
Summary:       CometD :: Java :: Oort

%description java-oort
CometD :: Java :: Oort.

%package java-server
Summary:       CometD :: Java :: Bayeux Server

%description java-server
CometD :: Java :: Bayeux Server.

%package java-websocket
Summary:       CometD :: Java :: WebSocket

%description java-websocket
CometD :: Java :: WebSocket.

%package java-websocket-common-client
Summary:       CometD :: Java :: WebSocket :: Common Client

%description java-websocket-common-client
CometD :: Java :: WebSocket :: Common Client.

%package java-websocket-common-server
Summary:       CometD :: Java :: WebSocket :: Common Server

%description java-websocket-common-server
CometD :: Java :: WebSocket :: Common Server.

%package java-websocket-javax-client
Summary:       CometD :: Java :: WebSocket :: JSR 356 Client

%description java-websocket-javax-client
CometD :: Java :: WebSocket :: JSR 356 Client.

%package java-websocket-javax-server
Summary:       CometD :: Java :: WebSocket :: JSR 356 Server

%description java-websocket-javax-server
CometD :: Java :: WebSocket :: JSR 356 Server.

%package java-websocket-jetty-client
Summary:       CometD :: Java :: WebSocket :: Jetty Client

%description java-websocket-jetty-client
CometD :: Java :: WebSocket :: Jetty Client.

%package java-websocket-jetty-server
Summary:       CometD :: Java :: WebSocket :: Jetty Server

%description java-websocket-jetty-server
CometD :: Java :: WebSocket :: Jetty Server.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n %{name}-%{namedversion}
%patch0 -p1
%patch1 -p1

%pom_remove_plugin :findbugs-maven-plugin
%pom_remove_plugin :jetty-maven-plugin
%pom_remove_plugin :maven-site-plugin
%pom_remove_plugin com.mycila:license-maven-plugin
%pom_remove_plugin :maven-release-plugin

# Usupported features (war, ...)
%pom_disable_module cometd-demo
%pom_disable_module cometd-archetypes
# Require a cleanup of bundle jquery libraries
%pom_disable_module cometd-javascript
# Unavailable deps
%pom_disable_module cometd-java-benchmark cometd-java

# Unwanted 
%pom_disable_module cometd-distribution
%pom_disable_module cometd-java-examples cometd-java

# Remove classifier hybrid @ org.eclipse.jetty.websocket:websocket-client:9.2.14.v20151106
%pom_xpath_remove "pom:dependency/pom:classifier" cometd-java/cometd-java-websocket/cometd-java-websocket-jetty-client

%pom_change_dep org.eclipse.jetty.toolchain:jetty-test-helper org.eclipse.jetty.toolchain:jetty-test-helper:1.0.5:test cometd-java/cometd-java-oort

# [ERROR] class file for org.eclipse.jetty.websocket.common.SessionListener not found
%pom_add_dep org.eclipse.jetty.websocket:websocket-common:'${jetty-version}':provided cometd-java/cometd-java-websocket/cometd-java-websocket-jetty-client

%mvn_package ":bayeux-api" bayeux-api

%build

# unavailable test deps springframework >= 4.2.4.RELEASE
%mvn_build -s -f -- -Dproject.build.sourceEncoding=UTF-8

%install
%mvn_install

%files -f .mfiles-%{name}-project
%doc README.md
%license LICENSE.txt

%files bayeux-api -f .mfiles-bayeux-api
%license LICENSE.txt

%files java -f .mfiles-%{name}-java
%license LICENSE.txt

%files java-annotations -f .mfiles-cometd-java-annotations
%license LICENSE.txt

%if 0
%files java-benchmark -f .mfiles-cometd-java-benchmark
%license LICENSE.txt

%files java-benchmark-client -f .mfiles-cometd-java-benchmark-client
%license LICENSE.txt

%files java-benchmark-common -f .mfiles-cometd-java-benchmark-common
%license LICENSE.txt

%files java-benchmark-server -f .mfiles-cometd-java-benchmark-server
%license LICENSE.txt
%endif

%files java-client -f .mfiles-cometd-java-client
%license LICENSE.txt

%files java-common -f .mfiles-cometd-java-common
%license LICENSE.txt

%files java-oort -f .mfiles-cometd-java-oort
%license LICENSE.txt

%files java-server -f .mfiles-cometd-java-server
%license LICENSE.txt

%files java-websocket -f .mfiles-cometd-java-websocket
%license LICENSE.txt

%files java-websocket-common-client -f .mfiles-cometd-java-websocket-common-client
%license LICENSE.txt

%files java-websocket-common-server -f .mfiles-cometd-java-websocket-common-server
%license LICENSE.txt

%files java-websocket-javax-client -f .mfiles-cometd-java-websocket-javax-client
%license LICENSE.txt

%files java-websocket-javax-server -f .mfiles-cometd-java-websocket-javax-server
%license LICENSE.txt

%files java-websocket-jetty-client -f .mfiles-cometd-java-websocket-jetty-client
%license LICENSE.txt

%files java-websocket-jetty-server -f .mfiles-cometd-java-websocket-jetty-server
%license LICENSE.txt

%files javadoc -f .mfiles-javadoc
%license LICENSE.txt

%changelog
* Sat Jan 23 2016 gil cattaneo <puntogil@libero.it> 3.0.9-1
- update to 3.0.9

* Sun Nov 29 2015 gil cattaneo <puntogil@libero.it> 3.0.7-1
- update to 3.0.7

* Mon Feb 02 2015 gil cattaneo <puntogil@libero.it> 3.0.3-1
- update to 3.0.3

* Sat Jul 06 2013 gil cattaneo <puntogil@libero.it> 2.7.0-0.1.beta1
- update to 2.7.0-beta1

* Fri May 31 2013 gil cattaneo <puntogil@libero.it> 2.6.0-1
- initial rpm
